<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="text"/>
    <xsl:variable name="EOL"><xsl:text>
</xsl:text></xsl:variable>

    <xsl:template match="query">
        <xsl:param name="indent"/>
        <xsl:choose>
            <xsl:when test="@select">
                <xsl:value-of select="$indent"/>SELECT <xsl:call-template name="PREFIX"/>.<xsl:value-of select="@select"/><xsl:value-of select="$EOL"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$indent"/>SELECT *<xsl:value-of select="$EOL"/>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:value-of select="$indent"/>FROM <xsl:value-of select="@from"/><xsl:text> </xsl:text><xsl:call-template name="PREFIX"/><xsl:value-of select="$EOL"/>
        <xsl:if test="*">
            <xsl:value-of select="$indent"/>WHERE<xsl:value-of select="$EOL"/>
            <xsl:apply-templates select="*">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
        </xsl:if>
    </xsl:template>

    <xsl:template match="in">
        <xsl:param name="indent"/>
        <xsl:value-of select="$indent"/><xsl:call-template name="PREFIX"/>.<xsl:value-of select="@column"/> IN<xsl:value-of select="$EOL"/>
        <xsl:value-of select="$indent"/>(<xsl:value-of select="$EOL"/>
        <xsl:apply-templates select="*">
            <xsl:with-param name="indent" select="concat($indent, '    ')"/>
        </xsl:apply-templates>
        <xsl:value-of select="$indent"/>)<xsl:value-of select="$EOL"/>
    </xsl:template>

    <xsl:template match="BooleanExpr">
        <xsl:param name="indent"/>
        <xsl:value-of select="$indent"/>(<xsl:value-of select="$EOL"/>
        <xsl:for-each select="*">
            <xsl:apply-templates select="self::*">
                <xsl:with-param name="indent" select="concat($indent, '    ')"/>
            </xsl:apply-templates>
            <xsl:if test="following-sibling::*">
                <xsl:value-of select="concat($indent, '    ')"/><xsl:value-of select="parent::BooleanExpr/@symbol"/><xsl:value-of select="$EOL"/>
            </xsl:if>
        </xsl:for-each>
        <xsl:value-of select="$indent"/>)<xsl:value-of select="$EOL"/>
    </xsl:template>

    <xsl:template match="NotExpr">
        <xsl:param name="indent"/>
        <xsl:value-of select="$indent"/>NOT<xsl:value-of select="$EOL"/>
        <xsl:value-of select="$indent"/>(<xsl:value-of select="$EOL"/>
        <xsl:apply-templates select="*">
            <xsl:with-param name="indent" select="concat($indent, '    ')"/>
        </xsl:apply-templates>
        <xsl:value-of select="$indent"/>)<xsl:value-of select="$EOL"/>
    </xsl:template>

    <xsl:template match="Comparison">
        <xsl:param name="indent"/>
        <xsl:value-of select="$indent"/><xsl:apply-templates select="Column"/>
            <xsl:text> </xsl:text><xsl:value-of select="@symbol"/><xsl:text> </xsl:text>
            <xsl:apply-templates select="Literal | Number"/><xsl:value-of select="$EOL"/>
    </xsl:template>

    <xsl:template match="Column">
        <xsl:call-template name="PREFIX"/>.<xsl:value-of select="text()"/>
    </xsl:template>

    <xsl:template match="Literal">'<xsl:value-of select="text()"/>'</xsl:template>
    <xsl:template match="Number"><xsl:value-of select="text()"/></xsl:template>

    <xsl:template name="PREFIX">
        <xsl:for-each select="ancestor-or-self::query[1]">t<xsl:value-of select="count(ancestor::query | preceding::query)+1"/></xsl:for-each>
    </xsl:template>
</xsl:stylesheet>